/**
 * @license
 * Copyright 2022 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Deferred_resolve, _Deferred_reject, _Deferred_settled;
/**
 * Convenience class for tracking a promise alongside its resolve and reject
 * functions.
 */
export class Deferred {
    constructor() {
        Object.defineProperty(this, "promise", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        _Deferred_resolve.set(this, void 0);
        _Deferred_reject.set(this, void 0);
        _Deferred_settled.set(this, false);
        this.promise = new Promise((resolve, reject) => {
            __classPrivateFieldSet(this, _Deferred_resolve, resolve, "f");
            __classPrivateFieldSet(this, _Deferred_reject, reject, "f");
        });
    }
    get settled() {
        return __classPrivateFieldGet(this, _Deferred_settled, "f");
    }
    resolve(value) {
        __classPrivateFieldSet(this, _Deferred_settled, true, "f");
        __classPrivateFieldGet(this, _Deferred_resolve, "f").call(this, value);
    }
    reject(reason) {
        __classPrivateFieldSet(this, _Deferred_settled, true, "f");
        __classPrivateFieldGet(this, _Deferred_reject, "f").call(this, reason);
    }
}
_Deferred_resolve = new WeakMap(), _Deferred_reject = new WeakMap(), _Deferred_settled = new WeakMap();
//# sourceMappingURL=deferred.js.map